C23456789012345678901234567890123456789012345678901234567890123456789012
      SUBROUTINE ELECTRONFLUX(KMAX,X,JMAX,Y,IMAX,Z,NC,ZA,ZN,EI,DN,BF,
     &     FTOP,FLUX,KB,KB1,KHS,KBC,KSY,KSMU,KTRM,KITM,KKR,X1,ADP,
     &     ADPM)
CINPUT:
C KMAX = NUMBER OF PITCH ANGLE POINTS, MAX = 30, EVEN NUMBERS ARE GOOD
C X = COS(PITCH ANGLE), FROM 1 TO -1, NO ZEROS ALLOWED
C JMAX = NUMBER OF DEPTH STEPS, MAX = 200 
C Y = DEPTH BIN EDGES IN CM(STARTS AT 0.0, MAX. IS 201)
C IMAX = NUMBER OF ENERGY STEPS
C Z = ENERGY IN UNITS OF MC2, MAX. IS 120
C 
C NC = NO. OF ATMOS. CONSTITUENTS IN MODEL UP TO 12, BUT
C      CONSTITUENT (3)  IS ELECTRONS
C      CONSTITUENTS (4 - NC) ARE IONS
C      TYPICALLY, 1 IS H, 2 IS HE, 3 MUST BE ELECTRONS, 
C      4 IS PROTONS, ETC.
C ZA = ATOMIC NUMBER FOR NEUTRAL ATMOSPHERIC CONSTITUENTS, 
C      FOR IONS:
C      CHARGE NUMBER (I.E. 1 FOR AN ION WITH 1 MISSING ELECTRON, 
C                          2 FOR AN ION WITH 2 MISSING ELECTRONS, ETC) 
C ZN = MOLECULAR WEIGHT
C EI = IONIZATION ENERGY, IN KEV, E.G.
C      11.5 FOR H, 41.5 HE, 0.0 FOR ELECTRONS AND IONS
C DN = DENSITY OF EACH CONSTITUENT AT POINTS Y MAXSIZE OF (12, 201)
C BF = MAGNETIC FIELD IN GAUSS FOR EACH Y
C FTOP = ELECTRON DISTRIBUTION AT THE TOP OF THE LOOP, FOR ALL ENERGY
C        AND PITCH ANGLE, AT LEAST THE X=1 ELEMENT MUST BE NONZERO
C KB = IF 0 THEN NO COULOMB ENERGY LOSS TERMS, IF 1 THEN ELOSS
C KB1 = IF 0 NO DIFFUSION, IF 1 KEEP DIFFUSION
C KHS = IF 0 NO MAGNETIC MIRRORING, IF 1 KEEP MIRRORING
C KBC = IF 0 NO REFLECION AT TOP, IF 1, REFLECT
C KSY = IF 0 NO SYNCH. LOSSES OR DIFFUSION, IF 1 ADD SYNCH LOSSES
C KSMU = IF 0 NO SYNCH. P.A. DIFFUSION, IF 1 ADD SYNCH PA. DIFFUSION
C KITM = NO. OF ITERATIONS ALLOWED PER ENERGY MAX = 9999
C KKR = NO. ITERAT. UNTIL  DIVERGENCE CHECK  1 TO 9999
C X1 = THE VALUE OF TAU/ETA ABOVE WHICH THE SOLUTION IS SET TO 0 
C      30 IS A GOOD VALUE
C ADP = DEGREE OF RELATIVE ACCURACY DESIRED (3E-7)
C ADPM = DEGREE OF RELATIVE ACCURACY REQUIRED (5E-1)
COUTPUT:
C FLUX = ELECTRON DISTRIBUTION AT ALL POINTS IN THE LOOP, FOR ALL
C        ANGLES AND ENERGIES
C
C ARRAY MAX SIZES
      PARAMETER(NDY=200,NDY1=201,NDX=30,NDZ=120,NDC=12)
      PARAMETER (XYZ=-39.0,NDXY=6000)	
C!SMALL #, WILL BE ZERO
      REAL MINSA,KAY,LSY,MUCR
C!LAST THREE FOR SYNCH. TERMS
      LOGICAL EMAX
C23456789012345678901234567890123456789012345678901234567890123456789012
C BIG MATRICES
      DIMENSION AM(NDXY,3),AUM(NDXY,2),ALM(NDXY,2),BCM(NDXY,3)
      DIMENSION FM(NDXY),HM(NDXY),FIN(NDY,NDX),FLUX(NDY,NDX,NDZ)
C Y DEPENDENT MATRICES
      DIMENSION B(NDY),B1(NDY),BI(NDY),BI1(NDY),BI1R(NDY),BIR(NDY)
      DIMENSION BY(NDY),CDZ(NDY),D(NDY),DY(NDY),Y(NDY1),BETA(NDY)
      DIMENSION BF(NDY1),TAU(NDY)
C X DEPENDENT MATRICES
      DIMENSION DX(NDX),DXMP(NDX),DXR(NDX),DXX(NDX),KXR(NDX)
      DIMENSION X(NDX),XFW(NDX),XMDX(NDX),XMP(NDX),XMP2(NDX)
      DIMENSION DPA(NDX),FMR(NDX),PA(NDX)
C Z DEPENDENT MATRICES
      DIMENSION Z(NDZ)
C C DEPENDENT MATRICES
      DIMENSION CS1(NDC),CS2(NDC),EI(NDC),DI(NDC)
      DIMENSION ZA(NDC),ZAC1(NDC),ZAC2(NDC),ZN(NDC)
C OTHERS
      DIMENSION DN(NDC,NDY1),FTOP(NDZ,NDX)
C!SYNCH TERMS
      DIMENSION CS2X(NDX),S2DXM(NDX),MUCR(NDY)
      DIMENSION LSY(NDY),KAY(NDY),SY0(NDY),SY0R(NDY)
C
C	GM1,3 AND DEM1,3 ARE EQUAL
C	AND ARE USED SIMULTANEOUSLY.
C
      EQUIVALENCE (GM1,DEM1),(GM3,DEM3)
C COMMON BLOCKS MAY JUST SPEED THINGS UP
      COMMON/BIG3S/ALM,AM,AUM,BCM
      COMMON/BIG1S/FM,HM
      COMMON/BNDRY/FMR,KXR,DXR
C KFD = WEIGHTING FOR FOCUSING TERM
C	THE WEIGHTING IS 1.0-ABS(X)**1/KFD
C	THE  LARGER  KFD THE MORE ACCURACY
C	THE SMALLER  KFD THE FASTER IS THE CONV.
      KFD=5
C NUMBER OF DEPTH*ANGLE POINTS
      NMAX=KMAX*JMAX
C PIES
      PIE=ATAN(1.0)*4.0
      PIEBY2=PIE/2.0
      TWOPIE=2.0*PIE
      SQPIE=SQRT(PIE)
C R0 = THE CLASSICAL ELECTRON RADIUS IN CM
      ZC = 0.8186E-06
      R0=2.818E-13
      QSY=6.4570E-20
C!QSY=2R0^2/3MC^2
      R0C=R0*R0*2.*PIE
      ALN2=ALOG(2.0)
C
      MINSA=37.854
      SPDL=2.9979E+10
      FLUXC=SPDL/2.
      BIG=10.0**38.0
      KERR=0
      KEST=0
C!ITERATION COUNTERS
      KKRR=KITM-KKR
C-      KITMS=KITM-KITS
C-      KITS1=KITS-1
      KRCF=0
C CLEAR BEFORE CALCULATING
      KIT=0
C!KIT=# OF ITERATIONS
      ITR=0
      DADP=BIG
C
      DO 10 J=1,NDY
         B(J)=0.0
         B1(J)=0.0
         BI(J)=0.0
         BI1(J)=0.0
         KAY(J)=0.0
         SY0(J)=0.0
 10   CONTINUE
C CLEAR FM (PLANE Z(IMAX) IS THE ZERO PLANE) , CLEAR HM ALSO
      DO 20 L=1,NDXY
         DO 16 LL=1,3
	    BCM(L,LL)=0.0
 16      CONTINUE
         HM(L)=0.0
         FM(L)=0.0
 20   CONTINUE
C
C-      KITS1=KITS-1
      KRCF=0
CK0 IS THE LAST + PITCH ANGLE, K1 IS THE FIRST - PITCH ANGLE
CNO ZERO PITCH ANGLES ARE ALLOWED
      DO 40 K=1,KMAX
         IF(X(K).GT.0.0) THEN 
            K0=K
         ELSE
            IF(X(K).EQ.0.0) THEN
               K1=K
               KMAX=KMAX-1
               DO 30 KK0=K1,KMAX
                  X(KK0)=X(KK0+1)
 30            CONTINUE
            ELSE
               IF(K0.EQ.(K-1)) K1=K
            ENDIF
         ENDIF
 40   CONTINUE
C
      K01=K0-1
      K11=K1+1
      ANMAX=NMAX/2
      KM=KMAX-1
      NM=NMAX-1
      IM=IMAX-1
      IMM=IM-1
      JM=JMAX-1
C
      Z00=Z(1)
      ZEF=Z(IMAX)
C
      JMP1=JMAX+1
      DO 130 J=1,JMAX
         L=JMP1-J
         DY(L)=Y(L+1)-Y(L)
 130  CONTINUE
C
      K5=KMAX-K0
      NL=NMAX-K5
C FORM THE X-LIST GIVEN X(K),K=1,2,...KMAX
      S2X=0.0
      DO 195 L=2,KMAX
         L1=L-1
         L2=L+1 
         S2XL1=S2X
         S2X=1.0-X(L)*X(L)
         CS2X(L)=X(L)*S2X
C!AT GRIDPT.
         DX(L1)=X(L1)-X(L)
         S2DXM(L1)=S2XL1*DX(L1)
C!SYNCH TERM
C XMP = MIDPOINT 'TWEEN OLD AND NEW X
         XMP(L1)=0.5*(X(L1)+X(L))
C XMP2 = (SIN(P.A.))**2 AT MIDPT.
         XMP2(L1)=(1.0-XMP(L1)*XMP(L1))
C PA = P.A. IN RADIANS
C DPA(K) = PA(K)-PA(K-1)
         PA(L)=ACOS(X(L))
         DPA(L)=PA(L)-PA(L1)
C FOCUSING TERM, LARGER KFD GIVES LARGER ACCURACY,
C SMALLER KFD GIVES FASTER CONVERGENCE
C WHY THIS WORKS IS NOT KNOWN...
         IF(KFD.GT.0) THEN
	    XFW(L)=1.0-ABS(X(L))**KFD
         ELSE
	    XFW(L)=0.0
         ENDIF
         XMDX(L1)=XMP2(L1)/DX(L1)
         IF(L.LT.KMAX) THEN
C DXMP(L)=0.5*(DX(L-1)+DX(L))     , L=2,3,4,...,KM
            DXMP(L)=(X(L1)-X(L2))/2.
            DXX(L)=DXMP(L)*X(L)
         ENDIF

 195  CONTINUE
C CALCULATE THE X-LIST FOR THE END OF THE RANGE
      DXMP(KMAX)=0.5*DX(KM)
      DXMP(1)=0.5*DX(1)
      DXX(1)=DXMP(1)
      XMP(KMAX)=0.
      PA(1)=0.
      DPA(1)=PA(2)
      XFW(1)=0.
      XMP2(KMAX)=0.0
      XMDX(KMAX)=0.0
      DXX(KMAX)=0.0
      DX(KMAX)=0.0
      DX2=DX(1)/2.0
      DXK2=DX(KM)/2.0
      DX1R=DX(1)/DX(2)
      DXKR=DX(KM)/DX(KM-1)
      DXR1=DX(1)/(DX(1)+DX(2))
      DXRK=DX(KM)/(DX(KM-1)+DX(KM))
      DXR1R=DXR1*DX1R
      DXKRK=DXKR*DXRK
      XK02=X(K0)*X(K0)
      XK12=-X(K1)*X(K1)
      DXK0= X(K0)+X(K0)
      DXK1=-X(K1)-X(K1)
C
      CS2X(1)=0.0
      CS2X(KMAX)=0.0
      S2DXM(1)=0.0
      S2DXM(KMAX)=0.0
CMAGNETIC FIELD TERMS
C        BETA=B(Y)/B0
C        BY=0.5*(DLOG(B)/DY)*DY
C        KAY=SYNCH. LOSS TERM
C        LSY=LENGTH SCALE FOR SYNCH LOSSES
CBF IS DEFINED ON Y EDGES HERE, BETA AT MIDPOINTS
      DO 200 L1=1,JMAX
         L2=L1+1
         BETA(L1)=SQRT(BF(L1)*BF(L2))/BF(1)
         BY(L1)=0.5*ALOG(BF(L2)/BF(L1))
 200  CONTINUE
      B02=BF(1)*BF(1)
C     
      DO 210 L1=1,JMAX
         IF(KSY.EQ.0) THEN
            KAY(L1)=0.0
            LSY(L1)=0.0
         ELSE
            BTL1=B02*BETA(L1)*BETA(L1)
            LSY(L1)=1.0/(QSY*BTL1)
            KAY(L1)=DY(L1)/LSY(L1)
         ENDIF
 210  CONTINUE
C FORM THE CONSTANTS NEEDED TO COMPUTE THE COULOMB TERMS
      DO 185 L=1,2
         ZAC1(L)=511000./EI(L)
         ZAC1(L)=ALOG(ZAC1(L))
 185  CONTINUE
C
C ZAC2(L)=-0.5*ALOG(2.0*(ZA(L)**2/3)/((137)**2))
      ZAC2(1)=4.5734
      ZAC2(2)=4.3424
C SET UP FOR THE TYPE OF BOUNDARY CONDITION
C KBC=0, ZERO BOUNDARY CONDITIONS,
C KBC=1, REFLECTING BOUNDARY CONDITIONS.
C FIND THE SYMMETRICAL INTERPOLATION CONSTANTS
      IF(KBC.GT.0) THEN
         L=KMAX
         DO 240 K=1,K0
	    FMR(K)=0.
 225	    TEMP=X(L)+X(K)
	    IF(TEMP.EQ.0.0) THEN
               DXR(K)=0.0
               KXR(K)=L
	    ELSE IF(TEMP.GT.0.0) THEN
               DXR(K)=TEMP/DX(L)
               KXR(K)=L
	    ELSE
               L=L-1
               IF(L.GE.K1) GO TO 225
               L=L+1
               IF(K.NE.K0) GO TO 820
               DXR(K)=0.0
               KXR(K)=L
	    ENDIF
 240     CONTINUE
      ENDIF
C THE ENERGY LOOP 
C START AT I=IMAX
      DZ=Z(IMAX)-Z(IM)
      I=IMAX
      DO 260 I = IMAX, 1, -1
         IF(I.EQ.IMAX) THEN
            FZI=0.0
            EMAX=.TRUE.
            ZEF=Z(I)
            Z1=Z(I)+1.0
            Z4=Z1+1.0
            Z2=Z(I)*Z4
C
C	Z3 = 1/BETA = SPDL / VELOCITY
C
C		T1-T   |BETA.BETA.T|
C	ZG3 =   ---- .		  1/2
C		 8
C
C	      T1-T	1
C	ZG1 ^ ---- . ------
C		8    T(T+2)
C
            Z3=Z1/SQRT(Z2)
            Z32=Z3*Z3
            VEL=SPDL/Z3
            ZI=Z(I)/Z32
            Z5=(Z32/Z2)/(32.0*DX(K0))
            ZY=Z(I)*Z(I)/Z1
C SYNCH TERMS
            IF(KSY.EQ.1) THEN
               Z10=Z(I)/(Z1*Z3)
C!Z*BETA/GAMMA
            ELSE
               Z10=0.0
            ENDIF
         ELSE
C START AT THE PLANE Z=Z(IMAX-1)
            IF(I.LT.1) GO TO 925
            EMAX=.FALSE.
            ZEF=Z(I)
            KIT=0
C
C FORM THE Z-LIST GIVEN Z(I),I=1,2,...IMAX
C	ZI = (T+2)*(T/T+1)**2
C
C	    (T+1)**2		1
C	Z5 = --------- * -------------------
C	     T(T+2)	32(X(K0)-X(K1))
C
            DZ=Z(I+1)-Z(I)
            DZ2=0.5*DZ
         ENDIF
C ZMP = MIDPOINT 'TWEEN Z(I) AND Z(I+1)
         ZMP=Z(I)+DZ2
         ZMPDZ=ZMP*DZ
         Z1=Z(I)+1.0
         ZYR=ZY
         ZY=Z(I)*Z(I)/Z1
         Z4=Z1+1.0
C COMPUTE (G1)/8.0
         ZG1=ALOG(1.0+DZ/Z4)/8.0
         Z2=Z(I)*Z4
C Z3 = 1/BETA = SPDL / VELOCITY
         Z3R=Z3
         Z32R=Z32
         Z3=Z1/SQRT(Z2)
C VELR = VEL @ PREVIOUS Z(I)
         VELR=VEL
         VEL=SPDL/Z3
         VELM=(VEL+VELR)*0.5
         VELZ=(VEL+VELR)*DZ
         Z1MP=ZMP+1.0
         Z4MP=Z1MP+1.0
         Z2MP=ZMP*Z4MP
         Z3MP=Z1MP/SQRT(Z2MP)
         Z32=Z3*Z3
         Z32DZ=Z32*DZ
         Z33=Z32*Z3
C ZIR = ZI @ PREVIOUS Z(I)
         ZIR=ZI
         ZI=Z(I)/Z32
C ZIMP = ZI @ T = ZMP
         ZIMP=ZMP*Z2MP/(Z1MP*Z1MP)
C COMPUTE (G3)/8.0
         ZG3=DZ*(ZI+ZIR+4.0*ZIMP)/48.0
         ZB=ZG3*4.0
C Z5R = Z5 @ PREVIOUS Z(I)
         Z5R=Z5
         Z5=(Z32/Z2)/(32.0*DX(K0))
         Z6=0.5*ALOG(Z2)
C Z7 = 0.5LN(T+1) + 0.5LNT(T+2)
         Z7=0.5*ALOG(Z(I))+Z6
         Z8=VELZ/(16.0*Z3)
         Z9=VELZ*(Z5+Z5R)/Z3
C MORE SYNCH TERMS
         IF(KSY.EQ.1) THEN
            Z10R=Z10
            Z10=Z(I)/(Z1*Z3)
            Z10MP=ZMP/(Z1MP*Z3MP)
            IF(KSMU.NE.0) THEN
               ZG4=DZ*(Z10+Z10R+4.0*Z10MP)/48.0
            ELSE
               ZG4=0.0
            ENDIF
C ZG4  IS THE D/DX TERM, ZQ THE D/DE TERM
            ZQ=0.5*Z2*ZMP/Z3
         ELSE
            ZG4=0.0
            ZQ=0.0
         ENDIF
C
C     NC = NUMBER OF ATMOSPHERIC CONSTITUENTS
C
C CS1(L)  HANDLES THE ENERGY LOST FROM THE
C ELECTRONS IN THE BEAM DUE TO CONSTITUENT L
C
C CS2(L)  HANDLES THE PITCH ANGLE DIFFUSION
C OF THE ELECTRONS IN THE BEAM DUE TO
C COLLISIONS WITH CONSTITUENT L
C
C COULOG = THE COULOMB LOGARITHM MINUS THE DENSITY DEPENDENCE
C	 = MINSA +2*(LnBETA) +0.5*(LnGAMMA)
C A TYPO EXISTS IN JL'S THESIS, THIS SHOULD BE
C	 = MINSA +2*(LnBETA) +(LnGAMMA)
C
C	COULOG=MINSA-2.0*ALOG(Z3)+0.5*ALOG(Z1)
C BREMSS ELOSS CORRECTION (CBR) ADDED 18-JUN-93 (jm)
C
         COULOG=MINSA-2.0*ALOG(Z3)+ALOG(Z1)
         CBR0=9.73E-3/Z32
         DO 290 L=1,2
            CS2(L)=ZA(L)*ZA(L)*(ZAC2(L)+Z6)
            CS1(L)=ZA(L)*(Z7+ZAC1(L))
            Z1CR=233.0/ZA(L)**0.333
            IF(Z1.GE.Z1CR) THEN
               CBR=CBR0*(1.0+Z1*ALOG(Z1CR))
            ELSE
               CBR=CBR0*(1.0+Z1*ALOG(Z1))
            ENDIF
            CS1(L)=CS1(L)+ZA(L)*ZA(L)*CBR
            IF(CS2(L).LE.0.0) CS2(L)=0.0
            IF(CS1(L).LE.0.0) CS1(L)=0.0
 290     CONTINUE
C STORE THE PREVIOUS BI
         DO 390 J=2,JMAX
            BI1R(J)=BI1(J)
            BIR(J)= ZMP*BI(J)
 390     CONTINUE
C CALCULATE B & B1 AT ALL HEIGHTS
         DO 335 L=1,JMAX
            B(L) = 0.0
            B1(L) = 0.0
C DI IS THE DENSITY OF EACH CONSTITUENT AT THIS BIN MIDPOINT
C BE CAREFUL ABOUT OVERFLOWS
            DO 295 L2=1, NC 
               DI(L2)=SQRT(DN(L2, L))*SQRT(DN(L2, L+1))
 295        CONTINUE
C
C B = 2*PI*SUM|CS1(L2)*DN(L2)|	FOR EACH GIVEN
C B1 = 2*PI*SUM|CS2(L2)*DN(L2)|	ALTITUDE
C
C B = 2*PI*(R0)**2* SUM | ZA(L2)*0.5*LN(T*T(T+2))*DN(L2) |
            DO 300 L2=1,2
               B(L)=B(L)+CS1(L2)*DI(L2)
               B1(L)=B1(L)+CS2(L2)*DI(L2)
 300        CONTINUE
C
            CS2(3)=COULOG-0.5*ALOG(DI(3))
            CS1(3)=CS2(3)
            Z1CR=233.0
            IF(Z1.GE.Z1CR) THEN
               CBR=CBR0*(1.0+Z1*ALOG(Z1CR))
            ELSE
               CBR=CBR0*(1.0+Z1*ALOG(Z1))
            ENDIF
            CS1(3)=CS1(3)+CBR
            B(L)=B(L)+CS1(3)*DI(3)
            B1(L)=B1(L)+CS2(3)*DI(3)
C CS1(L) L=4,NC = 0.0 (NOT TRUE WITH BREMSS CORRECTION)
            DO 305 L2=4,NC
               CS2(L2)=CS1(3)*ZA(L2)*ZA(L2)
               B1(L)=B1(L)+(CS2(L2)*DI(L2))
               Z1CR=233.0/ZA(L2)**0.333
               IF(Z1.GE.Z1CR) THEN
                  CBR=CBR0*(1.0+Z1*ALOG(Z1CR))
               ELSE
                  CBR=CBR0*(1.0+Z1*ALOG(Z1))
               ENDIF
               CS1(L2)=ZA(L2)*ZA(L2)*CBR
               B(L)=B(L)+(CS1(L2)*DI(L2))
 305        CONTINUE
C
            B(L)=B(L)*R0C
            B1(L)=B1(L)*R0C
            IF((B(L).LT.0.0).OR.(B1(L).LT.0.0)) GO TO 820
C ALSO GET BI AND BI1
            IF(L.EQ.1) THEN
               BI(L) = 0.0
               BI1(L) = 0.0
            ELSE
               BI(L) = B(L)*DY(L)
               BI1(L) = B1(L)*DY(L)
            ENDIF
 335     CONTINUE
C FIND TAU
C WE'LL TRUNCATE THE SOLUTION AT TAU=X1*ETA, WHERE X1 IS PASSED IN
         TAUI=0.0
         SUM=TAUI
         DO 460 J=1,JMAX
            SUM=SUM+2.0*BI(J)
            TAU(J)=SUM
 460     CONTINUE
C FOR KB=0 WE SET BI(J) TO ZERO
         IF(KB.EQ.0) THEN
            DO 465 J=1,JMAX
               BI(J)=0.0
 465        CONTINUE
         ENDIF
C FIND JSTOP WHERE WE TRUNCATE THE SOLUTION.
         DO 470 J=1,JMAX
            TEMP=X1*ZY
C!ZY=E^2/(E+1)
            IF(TAU(J).GT.TEMP) THEN	
               JSTOP=J
               GO TO 475
C!OUT OF LOOP
            ENDIF
 470     CONTINUE
         JSTOP=JMAX
 475     YMAX=Y(JSTOP)
CC
         KK=KITM
         REZ=1.0
         REZR=2.0
         DADP=-BIG
         KIS=0
C-         IF(KITMS.LT.0) KIS=KITS
C COMPUTE THE DJ/4 AND AJ/8 COEFFICIENTS
         TEMP=(DZ*ZMP)/((1.0+ZMP)*8.0)
         DO 490 J=1,JMAX
            CDZ(J)=ZG3*BY(J)
            D(J)=ZG1*(BI1(J)+BI1R(J))
            SY0R(J)=SY0(J)
            SY0(J)=ZQ*KAY(J)
C MUCR IS THE ANGLE AT WHICH FM GOES TO ZERO
C IN THE SYNCH ONLY CASE. I'LL USE IT IN T1 AND T2
            IF(LSY(J).NE.0.0) THEN
               VV=Z(I)*Y(J)/LSY(J)
C-               VV=Z(I)*(Y(J)+YI)/LSY(J)
               IF(VV.NE.0.0) THEN
                  MUCR(J)=(SQRT(1.0+4.0*VV*VV)-1.0)/(2.0*VV)
               ELSE
                  MUCR(J)=0.0
               ENDIF
            ELSE
               MUCR(J)=0.0
            ENDIF
 490     CONTINUE
C
C FORM THE MATRICES AM, BCM AND THE RIGHT HAND SIDE HM
C
C THE VECTOR HM IS THE ZEROTH ORDER 2-DIMENSIONAL VECTOR
C (HEIGHT AND PITCH ANGLE GRIDS) USED TO GIVE
C A ZEROTH ORDER APPROXIMATION TO THE FINAL RESULT
C FOR ENERGY LEVEL E(I). IT IS TAKEN FROM THE INPUT
C DATA AT THE TOP OF THE ATMOSPHERE IN THE FORWARD
C DIRECTION AND THE FINAL RESULT AT ENERGY LEVEL E(I+1).
C THE MATRIX AM IS THEN USED FOR THE ITERATIONS ON
C HM TO ARRIVE AT THE FINAL RESULT.
C 	A.f = h
C	WITH f BEING THE VECTOR FM AND
C	A THE MATRIX AM
C
C A IS FACTORISED INTO UPPER AND LOWER BIDIAGONAL MATRICES
C WITH Lii = Uii  INSTEAD OF THE MORE FAMILIAR Lii = 1.
C
C h = HM + SUM | BCM.YM |  WHERE YM IS THE LATEST
C
C ITERATION TOWARDS THE SOLUTION FM. THE VALUES OF HM
C ARE TAKEN AT THE POSITIONS (J-1/2,K) FOR POSITIVE P.A.
C AND AT (J+1/2,K) FOR NEGATIVE P.A.
C
         N1=K0
         N2=K1
C
         DO 500 J=2,JMAX
            M1=N1+KMAX
            M2=N2+KMAX
            L=K0
C!SYNCH.TERMS
            SY1=ZG4*KAY(J)
C DO THE NEGATIVE HALF
C WSA, WSB ARE D/DX TERMS, D(J) ARE THE D2/DX2 TERMS
C RC'S ARE THE REVERSE CURRENT, SY'S SYNCH TERMS AND
C TSA,TSB  ARE THE SYNCH D/DX TERMS
C WSB2,WSA2 ARE 'FOCUSING' TERMS
C
            DO 495 L1=K1,KM
               L2=L1+1
               N3=N2+1
               M3=M2+1
               WSA=CDZ(J)*XMP2(L1)
               WSA1=-WSA*XFW(L1)
               WSB=CDZ(J)*XMP2(L)
               WSB2=WSB*XFW(L1)  
C	    
               TSB=SY1*CS2X(L)
               TSA=SY1*CS2X(L2)
C
               AMN21=-D(J)*XMDX(L)-WSB
               AMN23=-D(J)*XMDX(L1)+WSA
C!XMPB IS THE D/DS TERM
               AMN22=-AMN21-AMN23
C!WSC, WSD ARE D/DE TERMS
               AMN21=AMN21+TSB
               AMN23=AMN23-TSA
C
               XMPB=DXX(L1)*ZB
C!THESE ONLY ON DIAGONAL
               XMPB2=2.0*XMPB
C
               WSD=DXMP(L1)*BIR(J)+SY0R(J)*S2DXM(L1)
               WSC=ZMP*DXMP(L1)*BI(J)+SY0(J)*S2DXM(L1)
C
               DEM1=-AMN21
               DEM3=-AMN23
               DEM2=-AMN22-XMPB+WSD
               GM2=DEM2+XMPB2
C
               HM(N2)=GM1*FM(N1)+GM2*FM(N2)+GM3*FM(N3)
     &              +DEM1*FM(M1)+DEM2*FM(M2)+DEM3*FM(M3)
C
C BCM(J,K,1) = -AM(J,K,1)
C BCM(J,K,2) = -AM(J,K,2) - 2XMPB
C BCM(J,K,3) = -AM(J,K,3)
C
               AM(N2,1)=AMN21-WSB2
               AM(N2,2)=AMN22-XMPB+WSB2-WSA1+WSC
               AM(N2,3)=AMN23+WSA1
               BCM(N2,2)=-AM(N2,2)-XMPB2
C
               N1=N2
               N2=N3
               M1=M2
               M2=M3
               L=L1
 495        CONTINUE
C
C DO X=-1.0
C
            N3=N2+1
            M3=M2+1
            L1=KMAX
C
            WSB=CDZ(J)*DXK2
            TSB=SY1*CS2X(KM)
C
            AM(N2,1)=-D(J)*(1.0+DXKR)-WSB+TSB
            AMN22   = D(J)*(1.0+DXRK)+WSB
            AM(N2,3)= D(J)*DXKRK
C
C D(J) IS THE ONLY TERM DEALING WITH A SECOND ORDER
C DIFFERENTIAL AND IS HENCE THE ONLY TERM INCLUDED IN AM(N2,3)
C
            DEM1=-AM(N2,1)
            DEM3=-AM(N2,3)
            GM2=-AMN22-DXMP(L1)*(ZB-BIR(J))
            DEM2=-AMN22+DXMP(L1)*(ZB+BIR(J))
C
            WSC=ZMP*BI(J)
C!ONLY ON DIAGONAL
C
            BCM(N2,2)=-AMN22+DXMP(L1)*(ZB-WSC)
            AM(N2,2)=AMN22+DXMP(L1)*(ZB+WSC)
            HM(N2)=GM1*FM(N1)+GM2*FM(N2)+GM3*FM(N1-1)
     &           +DEM1*FM(M1)+DEM2*FM(M2)+DEM3*FM(M1-1)
C
C DO X=+1.0
C
            N1=N2
            N2=N3
            M1=N1-KMAX
            M2=N2-KMAX
            N3=N2+1
            M3=N3-KMAX
C
            WSA=CDZ(J)*DX2
            TSA=SY1*CS2X(2)
C
            AM(N2,1)= D(J)*DXR1R
            AMN22   = D(J)*(1.0+DXR1)-WSA
            AM(N2,3)=-D(J)*(1.0+DX1R)+WSA-TSA
C
            DEM1=-AM(N2,1)
            DEM3=-AM(N2,3)
            DEM2=-AMN22+DXMP(1)*(ZB+BIR(J))
            GM2=-AMN22-DXMP(1)*(ZB-BIR(J))
C
            BCM(N2,2)=-AMN22+DXMP(1)*(ZB-WSC)
            AM(N2,2)=AMN22+DXMP(1)*(ZB+WSC)
            HM(N2)= GM1*FM(N3+1)+GM2*FM(N2)+GM3*FM(N3)
     &           +DEM1*FM(M3+1)+DEM2*FM(M2)+DEM3*FM(M3)
C
C DO THE POSITIVE HALF
C
            N1=N2
            N2=N3
            M1=M2
            M2=M3
            L=1
C
            DO 497 L1=2,K0
               L2=L1+1
               N3=N2+1
               M3=M2+1
C
               WSA=CDZ(J)*XMP2(L1)
               WSA1=-WSA*XFW(L1)
               WSB=CDZ(J)*XMP2(L)
               WSB2=WSB*XFW(L1)
C     
               TSA=SY1*CS2X(L2)
               TSB=SY1*CS2X(L)
C
               AMN21=-D(J)*XMDX(L)-WSB
               AMN23=-D(J)*XMDX(L1)+WSA
               AMN22=-AMN21-AMN23
               AMN21=AMN21+TSB
               AMN23=AMN23-TSA
C
               XMPB=DXX(L1)*ZB
               XMPB2=2.0*XMPB
C
               WSD=DXMP(L1)*BIR(J)+SY0R(J)*S2DXM(L1)
               WSC=ZMP*DXMP(L1)*BI(J)+SY0(J)*S2DXM(L1)
C
               DEM1=-AMN21
               DEM3=-AMN23
               DEM2=-AMN22+XMPB+WSD
               GM2=DEM2-XMPB2
C
               HM(N2)=GM1*FM(N1)+GM2*FM(N2)+GM3*FM(N3)
     &              +DEM1*FM(M1)+DEM2*FM(M2)+DEM3*FM(M3)
C
C BCM(J,K,1) = -AM(J,K,1)
C BCM(J,K,2) = -AM(J,K,2) + 2XMPB
C BCM(J,K,3) = -AM(J,K,3)
C
               AM(N2,1)=AMN21-WSB2
               AM(N2,2)=AMN22+XMPB+WSB2-WSA1+WSC
               AM(N2,3)=AMN23+WSA1
               BCM(N2,2)=-AM(N2,2)+XMPB2
C
               N1=N2
               N2=N3
               M1=M2
               M2=M3
               L=L1
 497        CONTINUE
 500     CONTINUE
C GET INPUT FOR THE FIRST LINE CALL PDIST(Y,FMR,NZ,KT,*820)
         DO 1500 K=1,KMAX
            FM(K)=FTOP(I,K)
            FMR(K)=FM(K)
 1500    CONTINUE
C FOR THE REST OF THE LOOP TAKE THE SOLUTION AT THE NEXT HIGHEST
C ENERGY AND GUESS PROPORTIONAL TO THE ENERGY DISTRIBUTION
         IF(I.LT.IMAX) THEN
            FZIR=FTOP(I,1)/FTOP(I+1,1)
            DO 1510 N=K1,NMAX
               FM(N)=FZIR*FM(N)
 1510       CONTINUE
         ENDIF
C
C NL=JM.KMAX+K0
C
         DO 505 M=K1,NL
            BCM(M,1)=-AM(M,1)
            BCM(M,3)=-AM(M,3)
 505     CONTINUE
C
C MODIFY HM FOR THE FIRST (-) POINT OF THE FIRST LINE
C
         HM(K1)=HM(K1)-FM(K0)*AM(K1,1)
         AM(NL,3)=0.0
C
C FACTOR AM INTO BIDIAGONAL ALM AND AUM
C
         CALL FACTOR(KMAX,KM,K0,K1,K5,JMAX,JM)
C
C NOW ITERATE ON THIS PLANE,(LY=H AND UF=Y)
C
 520     KIT=KIT+1
         KK=KK-1
C
C WE CAN STILL ITERATE IF KK.GE.0
C
         IF(KK.LT.0) GO TO 595
C
C CHECK CONVERGENCE, RATE IS OK IF KK.GE.KEST
C
         IF(KK.LT.KKRR) THEN
            KKRR=KKRR-KKR
C!OMIT NEXT KKR TIMES
            IF(KK.LT.KEST) THEN
               IF(DADPM.LT.0.0) THEN
C!NO ACCURACY
                  WRITE(6,*) 'DADPM=',DADPM
                  GO TO 820
C!OUTPUT AND END
               ENDIF
               GO TO 595
            ENDIF
         ENDIF
C
C TRIM REMOVES NEGATIVE OUTPUT, T1 TRUNCATES, RINGER SOLVES
C
 580     IF(KTRM.EQ.0) THEN
            CALL TRIM(KHS,KB1,KMAX,KM,K0,K1,JMAX,JM,NMAX)
            CALL TRIM1(DPA,X,MUCR,JMAX,KMAX,KM,B2,A02,JSTOP)
         ENDIF
C RINGER GETS THE SOLUTION
         CALL RINGER(KMAX,KM,K0,K1,K5,JMAX,JM,NMAX,KBC,REZ,DDREZ)
C
         IF(DDREZ.EQ.0.0) THEN
            WRITE(6,*) 'DDREZ = 0.0, FOR I=', I
            GO TO 925
C!OUT OF PROGRAM
         ENDIF
C
         REZ=REZ/DDREZ
         DREZ=REZR-REZ
         REZR=REZ
         IF(DREZ.GT.0.0) THEN
            DADP=ADP-REZ
            DADPM=ADPM-REZ
            KEST=-DADP/DREZ-0.5
         ENDIF
C
C THE DESIRED ACCURACY IS ACHIEVED FOR DADP>0
C
         IF(DADP.LT.0.0) GO TO 520
C
 595     IF(KTRM.EQ.0) THEN
            CALL TRIM(KHS,KB1,KMAX,KM,K0,K1,JMAX,JM,NMAX)
         ENDIF
C
 600     ITR=ITR+KIT
C TRIM2 WILL RETURN FIN, A TRIMMED VERSION WITH
C "BAD" PARTS DELETED
         CALL TRIM2(FM,FIN,X,MUCR,JMAX,KMAX,JSTOP,KFAN)
C
C ONCE I HAVE TWO ZEROS IN A ROW, SOLUTION IS BAD
C UNLESS THEY ARE FOR X<0 OR NEAR X=0 FOR
C HIGH FIELDS. REMAINING FIN'S ARE ZERO 
C IN UNITS OF FLUX/KEV
C FILL FLUX OUTPUT ARRAY
         CLL1=1.0/511000.0
         DO 1590 K=1,KMAX
            DO 1600 J=1,JMAX
               FLUX(J,K,I) = CLL1*FIN(J,K)
 1600       CONTINUE
 1590    CONTINUE
C END ENERGY LOOP
 260  CONTINUE
 910  FORMAT(' ERROR')
 820  CONTINUE
 925  END
